#ifndef __BMP_PARAMSPECS_H__
#define __BMP_PARAMSPECS_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

extern GType *bmp_param_spec_types;

/* --- type macros --- */
#define	BMP_TYPE_PARAM_LIST		   (bmp_param_spec_types[0])
#define BMP_IS_PARAM_SPEC_LIST(pspec)      (G_TYPE_CHECK_INSTANCE_TYPE ((pspec), BMP_TYPE_PARAM_LIST))
#define BMP_PARAM_SPEC_LIST(pspec)         (G_TYPE_CHECK_INSTANCE_CAST ((pspec), BMP_TYPE_PARAM_LIST, BmpParamSpecList))

void
bmp_param_spec_types_init (void);	
 
/* --- typedefs & structures --- */
typedef struct _BmpParamSpecList       BmpParamSpecList;

struct _BmpParamSpecList
{
  GParamSpec    parent_instance;

  GList	       *list;  
  gint		default_value;
};

/* --- GParamSpec prototypes --- */
GParamSpec*	bmp_param_spec_list	 (const gchar	 *name,
					  const gchar	 *nick,
					  const gchar	 *blurb,
					  GList		 *list,
					  gint		  default_value,
					  GParamFlags	  flags);

G_END_DECLS

#endif /* __G_PARAMSPECS_H__ */
