#include <gtk/gtk.h>

G_BEGIN_DECLS

/* Designate dropped data types that we know and care about */
enum {
    BMP_DROP_QUERY,
    BMP_DROP_PLAINTEXT,
    BMP_DROP_URLENCODED,
    BMP_DROP_STRING,
};

/* Drag data format listing for gtk_drag_dest_set() */
static const GtkTargetEntry cl_drop_types[] = {
    {"application/x-bmpx-db-query", 0, BMP_DROP_QUERY},
    {"text/plain",		    0, BMP_DROP_PLAINTEXT},
    {"text/uri-list",		    0, BMP_DROP_URLENCODED},
    {"STRING",			    0, BMP_DROP_STRING},
};

#define cl_drag_dest_set(widget) \
    gtk_drag_dest_set(widget, \
		      GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_DROP, \
		      cl_drop_types, 3, \
                      GDK_ACTION_COPY | GDK_ACTION_MOVE)

G_END_DECLS
