/*  libhrel - Holyrel library

    Copyright (C) 2005 Chong Kai Xiong <descender@phreaker.net>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA  02111-1307  USA.
*/

#ifndef H_RELATION_INTERSECT_H
#define H_RELATION_INTERSECT_H

#include <glib.h>
#include <libhrel/relation.h>

G_BEGIN_DECLS

#define H_TYPE_RELATION_INTERSECT            (h_relation_intersect_get_type ())
#define H_RELATION_INTERSECT(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), H_TYPE_RELATION_INTERSECT, HRelationIntersect))
#define H_RELATION_INTERSECT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST    ((klass), H_TYPE_RELATION_INTERSECT, HRelationIntersectClass))
#define H_IS_RELATION_INTERSECT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), H_TYPE_RELATION_INTERSECT))
#define H_IS_RELATION_INTERSECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE    ((klass), H_TYPE_RELATION_INTERSECT))
#define H_RELATION_INTERSECT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS  ((obj), H_TYPE_RELATION_INTERSECT, HRelationIntersectClass))

typedef struct _HRelationIntersect      HRelationIntersect;
typedef struct _HRelationIntersectClass HRelationIntersectClass;

struct _HRelationIntersect
{
  HRelation relation;
};

struct _HRelationIntersectClass
{
  HRelationClass relation_class;
};

GType      h_relation_intersect_get_type (void);
HRelation *h_relation_intersect          (HRelation *relation1,
                                          HRelation *relation2);

G_END_DECLS

#endif /* #ifndef H_RELATION_INTERSECT_H */
