/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 *
 */

#ifndef _PLUGIN_PRIV_H_
#define _PLUGIN_PRIV_H_

#include <bmp/plugin.h>

typedef enum {

    BMP_PLUGIN_TYPE_FLOW,
    BMP_PLUGIN_TYPE_CONTAINER,
    BMP_PLUGIN_TYPE_TRANSPORT,

    BMP_N_PLUGIN_TYPES
} PluginType;

typedef struct {
	gchar *name;
	gchar *desc;
	gchar *suffix;
} ContainerHTuple;

extern GHashTable   *plugins_table[BMP_N_PLUGIN_TYPES];

void
plugins_initialize	(void);

void
plugins_shutdown	(void);

GList*
plugins_find_containers (void);

/* Auxilliary */
void
container_h_tuple_free	(gpointer data);

const gchar*
plugin_type_get_name	(PluginType type);

const gchar*
plugin_type_get_desc	(PluginType type);
 
#endif /* _PLUGIN_PRIV_H_ */
