/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 *
 */

/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */

#ifndef BMP_LOGGER_H
#define BMP_LOGGER_H

/*
 * Potentially, include other headers on which this header depends.
 */
#include <glib-object.h>

#define BMP_TYPE_LOGGER			    (bmp_logger_get_type ())
#define BMP_LOGGER(obj)			    (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_LOGGER, BmpLogger))
#define BMP_LOGGER_CLASS(klass)		    (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_LOGGER, BmpLoggerClass))
#define BMP_IS_LOGGER(obj)		    (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_LOGGER))
#define BMP_IS_LOGGER_CLASS(klass)	    (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_LOGGER))
#define BMP_LOGGER_GET_CLASS(obj)	    (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_LOGGER, BmpLoggerClass))

typedef struct _BmpLogger BmpLogger;
typedef struct _BmpLoggerClass BmpLoggerClass;
typedef struct _BmpLoggerPrivate BmpLoggerPrivate;

struct _BmpLogger {
	GObject parent;

        BmpLoggerPrivate *private;
};

struct _BmpLoggerClass {
	GObjectClass parent;

};

#define LOG_ALL_LEVELS (G_LOG_LEVEL_MASK | G_LOG_FLAG_FATAL | G_LOG_FLAG_RECURSION)
#define BMP_LOGGER_DEFAULT_LOG_LEVEL  G_LOG_LEVEL_MESSAGE

/* default log file max size: 512kb */
#define BMP_LOGGER_FILE_MAX_SIZE      ((size_t)1 << 19)

GType
bmp_logger_get_type (void);

BmpLogger*
bmp_logger_new (void);

gboolean
bmp_logger_add_log (BmpLogger		*self,
		    const gchar		*domain,
		    const gchar		*filename,
		    GLogLevelFlags	 flags);

/* aux stuff */
gchar*
get_timestamp_str (void);
 
#endif /* BMP_LOGGER_H */



