#ifndef MAIN_H
#define MAIN_H

#include <config.h>

#ifdef HAVE_GUI
#include "ui.h"
#endif

#include "fam_monitor.h"
#include "gc.h"
#include "play.h"
#if 0
#include "plmanager.h"
#endif
#include "resource_manager.h"
#include "system_control.h"
#include "scrobbler.h"

#include <xcs/xcs.h>
#include <bmp/playlist.h>

#ifdef HAVE_HAL
#include <bmp/hal.h>
#endif

//Those go into XDG cache
#define BMP_SKIN_THUMB_DIR_BASENAME   "thumbs"
#define BMP_COVER_THUMB_DIR_BASENAME  "covers"
#define BMP_XDG_CACHE_BASEDIR	       PACKAGE 


#define BMP_SKIN_DIR_BASENAME         "skins"
#define BMP_LOGS_BASENAME             "logs"
#define BMP_PLAYLISTS_DIR_BASENAME    "playlists"
#define BMP_TAGS_DIR_BASENAME	      "tags"

#define BMP_UI_BASENAME		      "ui"
#define BMP_DATA_BASENAME	      "data"
#define BMP_IMAGES_BASENAME	      "images"
#define BMP_ICONS_BASENAME	      "icons/themes"

#define BMP_PATH_LOGS_DIR             bmp_paths[0]
#define BMP_PATH_USER_DIR             bmp_paths[1]
#define BMP_PATH_USER_PLUGIN_DIR      bmp_paths[2]
#define BMP_PATH_USER_SKIN_DIR        bmp_paths[3]
#define BMP_PATH_SKIN_THUMB_DIR       bmp_paths[4]
#define BMP_PATH_ACCEL_FILE           bmp_paths[5]
#define BMP_PATH_CONFIG_FILE          bmp_paths[6]
#define BMP_PATH_PLAYLISTS            bmp_paths[7]
#define BMP_PATH_METADATA_CACHE       bmp_paths[8]
#define BMP_PATH_COVER_THUMB_DIR      bmp_paths[9]
#define BMP_N_PATHS                   10 

extern gchar *bmp_paths[BMP_N_PATHS];

#include <bmp/objects.h>

extern Xcs		  *_xcs;
extern BmpResourceManager *_bmp_rm;
extern BmpPlaylist        *_bmp_playlist;
extern BmpPlay		  *_bmp_play_engine;
extern BmpSystemControl   *_bmp_system_control;
extern FamMonitor	  *_bmp_fam_monitor;
#if 0
extern PLManager	  *_bmp_pl_manager;
#endif
#ifdef HAVE_HAL
extern BmpHal		  *_bmp_hal;
#endif

extern BmpScrobbler	  *_bmp_scrobbler;

#define xcs		    XCS_CONFIGURATION(g_atomic_pointer_get(&_xcs)) 
#define bmp_rm		    BMP_RESOURCE_MANAGER((g_atomic_pointer_get(&_bmp_rm))) 
#define bmp_mb		    BMP_MB((g_atomic_pointer_get(&_bmp_mb))) 
#define bmp_metadata_cache  BMP_METADATA_CACHE((g_atomic_pointer_get(&_bmp_metadata_cache))) 
#define bmp_playlist	    BMP_PLAYLIST((g_atomic_pointer_get(&_bmp_playlist))) 
#define bmp_play_engine	    PLAY((g_atomic_pointer_get(&_bmp_play_engine))) 
#define bmp_system_control  BMP_SYSTEM_CONTROL(g_atomic_pointer_get(&_bmp_system_control)) 
#define bmp_fam_monitor	    FAM_MONITOR(g_atomic_pointer_get(&_bmp_fam_monitor)) 
#if 0
#define bmp_pl_manager	    PL_MANAGER(g_atomic_pointer_get(&_bmp_pl_manager)) 
#endif
#define bmp_hal		    BMP_HAL(g_atomic_pointer_get(&_bmp_hal)) 
#define bmp_scrobbler       BMP_SCROBBLER(g_atomic_pointer_get(&_bmp_scrobbler)) 

#ifdef HAVE_GUI
extern BmpUI              *_bmp_ui;
#define bmp_ui		    BMP_UI(g_atomic_pointer_get(&_bmp_ui)) 
extern gboolean		   progress_running;
extern gboolean		   use_xdb;
extern gboolean		   run_headless;
#endif
#ifndef HAVE_GUI
extern GMainLoop	  *mainloop;
#endif

extern NGC		  *ngc;

#endif
