/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 */

#include <libhrel/types.h>
#include <libhrel/relation.h>

#include <bmp/metadata.h>
#include <bmp/metadata_common.h>


HRelation*
create_relation_base_track (void)
{
  HRelation *relation;

  relation = h_relation_base_new ("track",
				  TRACK_RELATION_DESCRIPTION, 
				  bmp_metadata_get_id_static (BMP_DATUM_ARTIST),  bmp_metadata_get_type (BMP_DATUM_ARTIST),
				  bmp_metadata_get_id_static (BMP_DATUM_ALBUM),	  bmp_metadata_get_type (BMP_DATUM_ALBUM),
				  bmp_metadata_get_id_static (BMP_DATUM_TITLE),	  bmp_metadata_get_type (BMP_DATUM_TITLE),
				  bmp_metadata_get_id_static (BMP_DATUM_TRACK),	  bmp_metadata_get_type (BMP_DATUM_TRACK),
				  bmp_metadata_get_id_static (BMP_DATUM_TIME),	  bmp_metadata_get_type (BMP_DATUM_TIME),
				  bmp_metadata_get_id_static (BMP_DATUM_GENRE),	  bmp_metadata_get_type (BMP_DATUM_GENRE),
				  bmp_metadata_get_id_static (BMP_DATUM_COMMENT), bmp_metadata_get_type (BMP_DATUM_COMMENT),
				  bmp_metadata_get_id_static (BMP_DATUM_RATING),  bmp_metadata_get_type (BMP_DATUM_RATING),
				  bmp_metadata_get_id_static (BMP_DATUM_DATE),	  bmp_metadata_get_type (BMP_DATUM_DATE),
				  bmp_metadata_get_id_static (BMP_DATUM_MTIME),	  bmp_metadata_get_type (BMP_DATUM_MTIME),
				  bmp_metadata_get_id_static (BMP_DATUM_BITRATE), bmp_metadata_get_type (BMP_DATUM_BITRATE),
				  bmp_metadata_get_id_static (BMP_DATUM_SAMPLERATE),  bmp_metadata_get_type (BMP_DATUM_SAMPLERATE),
				  bmp_metadata_get_id_static (BMP_DATUM_COUNT),	  bmp_metadata_get_type (BMP_DATUM_COUNT),
				  bmp_metadata_get_id_static (BMP_DATUM_LOCATION), bmp_metadata_get_type (BMP_DATUM_LOCATION),
				  bmp_metadata_get_id_static (BMP_DATUM_HAL_VOLUME_UDI), bmp_metadata_get_type (BMP_DATUM_HAL_VOLUME_UDI),
				  bmp_metadata_get_id_static (BMP_DATUM_HAL_DEVICE_UDI), bmp_metadata_get_type (BMP_DATUM_HAL_DEVICE_UDI),
				  NULL,
				  bmp_metadata_get_id_static (BMP_METADATA_PKEY), 
				  NULL);

  return relation;
}
