#include	<string.h>
#include	<glib.h>
#include	<glib-object.h>
#include	<bmp/paramspecs.h>

/* --- type initialization --- */
GType *bmp_param_spec_types = NULL;

/* --- param spec functions --- */
static void
param_list_init (GParamSpec *pspec)
{
  BmpParamSpecList *lspec = BMP_PARAM_SPEC_LIST (pspec);
  
  lspec->list = NULL;
  lspec->default_value = 0;
}

static void
param_list_set_default (GParamSpec *pspec,
			GValue	   *value)
{
  value->data[0].v_pointer = BMP_PARAM_SPEC_LIST (pspec)->list;
  value->data[0].v_int = BMP_PARAM_SPEC_LIST (pspec)->default_value;
}

void
bmp_param_spec_types_init (void)	
{
  const guint n_types = 1;
  GType type, *spec_types, *spec_types_bound;

  bmp_param_spec_types = g_new0 (GType, n_types);
  spec_types = bmp_param_spec_types;
  spec_types_bound = bmp_param_spec_types + n_types;
  
  /* G_TYPE_PARAM_CHAR
   */
  {
    static const GParamSpecTypeInfo pspec_info = {
      sizeof (BmpParamSpecList),	/* instance_size */
      16,			/* n_preallocs */
      param_list_init,		/* instance_init */
      G_TYPE_POINTER,		/* value_type */
      NULL,			/* finalize */
      param_list_set_default,	/* value_set_default */
      NULL, 
      NULL,
    };
    type = g_param_type_register_static ("BmpParamList", &pspec_info);
    *spec_types++ = type;
    g_assert (type == BMP_TYPE_PARAM_LIST);
  }
  
  g_assert (spec_types == spec_types_bound);
}

/* --- GParamSpec initialization --- */

GParamSpec*
bmp_param_spec_list (const gchar *name,
		     const gchar *nick,
		     const gchar *blurb,
		     GList	 *list,
		     gint	  default_value,
		     GParamFlags  flags)
{
  BmpParamSpecList *lspec;

  lspec = g_param_spec_internal (BMP_TYPE_PARAM_LIST,
				 name,
				 nick,
				 blurb,
				 flags);
  
  lspec->list = list;
  lspec->default_value = default_value;
  
  return G_PARAM_SPEC (lspec);
}
