/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 *
 */
/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */

#ifndef _PLUGIN_HOST_H_
#define _PLUGIN_HOST_H_

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#include "loader.h"

#define BMP_TYPE_PLUGIN_HOST		    (bmp_plugin_host_get_type ())
#define BMP_PLUGIN_HOST(obj)		    (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_PLUGIN_HOST, BmpPluginHost))
#define BMP_PLUGIN_HOST_CLASS(klass)	    (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_PLUGIN_HOST, BmpPluginHostClass))
#define BMP_IS_PLUGIN_HOST(obj)	    (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_PLUGIN_HOST))
#define BMP_IS_PLUGIN_HOST_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_PLUGIN_HOST))
#define BMP_PLUGIN_HOST_GET_CLASS(obj)	    (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_PLUGIN_HOST, BmpPluginHostClass))

typedef struct _BmpPluginHost BmpPluginHost;
typedef struct _BmpPluginHostClass BmpPluginHostClass;
typedef struct _BmpPluginHostPrivate BmpPluginHostPrivate;

struct _BmpPluginHost {
	GObject parent;

        BmpPluginHostPrivate *private;
};

struct _BmpPluginHostClass {
	GObjectClass parent;
};

typedef struct _PluginHostPropertyData PluginHostPropertyData;
struct _PluginHostPropertyData {
	PluginType    type;
	gchar	     *name;
	GQuark	      property;
};

GType
bmp_plugin_host_get_type (void);

BmpPluginHost*
bmp_plugin_host_new      (void);

void
bmp_plugin_host_create_gui_for_plugin (BmpPluginHost	  *self,
					        PluginType		   type,
						const gchar		  *name);

void
bmp_plugin_host_gui_show (BmpPluginHost	  *self,
				   PluginType			   type,
				   const gchar			  *name);
 
#endif /* BMP_PLUGIN_HOST_H */



