/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id$
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 *
 */

/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */

#ifndef SCROBBLER_H
#define SCROBBLER_H

#include <glib-object.h>

G_BEGIN_DECLS

#define BMP_TYPE_SCROBBLER		    (bmp_scrobbler_get_type ())
#define BMP_SCROBBLER(obj)		    (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_SCROBBLER, BmpScrobbler))
#define BMP_SCROBBLER_CLASS(klass)	    (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_SCROBBLER, BmpScrobblerClass))
#define BMP_IS_SCROBBLER(obj)	  	    (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BMP_TYPE_SCROBBLER))
#define BMP_IS_SCROBBLER_CLASS(klass)	    (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_SCROBBLER))
#define BMP_SCROBBLER_GET_CLASS(obj)	    (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_SCROBBLER, BmpScrobblerClass))

typedef struct _BmpScrobbler BmpScrobbler;
typedef struct _BmpScrobblerClass BmpScrobblerClass;
typedef struct _BmpScrobblerPrivate BmpScrobblerPrivate;

struct _BmpScrobbler {
	GObject parent;

        BmpScrobblerPrivate *private;
};

struct _BmpScrobblerClass {
	GObjectClass parent;
};

GType
bmp_scrobbler_get_type (void);

BmpScrobbler*
bmp_scrobbler_new ();

G_END_DECLS

#endif
