#ifndef _SIGNAL_HANDLER_POOL_H_
#define _SIGNAL_HANDLER_POOL_H_

#include <glib.h>
#include <glib-object.h>

typedef struct _SignalHandlerPoolTuple SignalHandlerPoolTuple; 
struct _SignalHandlerPoolTuple {
    gpointer instance;
    gulong   handler;
};
#define SIGNAL_HANDLER_POOL_TUPLE(x) ((SignalHandlerPoolTuple*)(x))

typedef struct _SignalHandlerPool SignalHandlerPool; 
struct _SignalHandlerPool {
    gchar     *name;
    GList     *conns;
};

SignalHandlerPool*
signal_handler_pool_new (const gchar *name);

void
signal_handler_pool_add_connection (SignalHandlerPool	  *pool,
				    gpointer		   instance,
				    const gchar		  *sigspec,
				    GCallback		   callback,
				    gpointer		   data,
				    GConnectFlags	   flags);

void
signal_handler_pool_free	    (SignalHandlerPool	  *pool);


#endif
