/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 */

#ifndef _DIALOG_RADIO_STREAMS_H
#define _DIALOG_RADIO_STREAMS_H

#include <glib-object.h>
#include <bmp/metadata.h>

#define BMP_TYPE_RADIO_STREAMS			  (bmp_streams_get_type ())
#define BMP_RADIO_STREAMS(obj)			  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_RADIO_STREAMS, BmpRadioStreams))
#define BMP_RADIO_STREAMS_CLASS(klass)		  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_RADIO_STREAMS, BmpRadioStreamsClass))
#define BMP_IS_RADIO_STREAMS(obj)		  (GTK_CHECK_TYPE ((obj), BMP_TYPE_RADIO_STREAMS))
#define BMP_IS_RADIO_STREAMS_CLASS(klass)	  (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_RADIO_STREAMS))
#define BMP_RADIO_STREAMS_GET_CLASS(obj)	  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_RADIO_STREAMS, BmpRadioStreamsClass))

typedef struct _BmpRadioStreams BmpRadioStreams;
typedef struct _BmpRadioStreamsClass BmpRadioStreamsClass;
typedef struct _BmpRadioStreamsPrivate BmpRadioStreamsPrivate;

struct _BmpRadioStreams {
	GObject parent;

        BmpRadioStreamsPrivate *private;

    	GtkWidget *window;
};

struct _BmpRadioStreamsClass {
	GObjectClass parent;
};

GType 
bmp_streams_get_type  (void);

BmpRadioStreams*
bmp_streams_new	      (void);
 
void
bmp_streams_show      (BmpRadioStreams *this);

#endif

