/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 */

#ifndef _TRACKINFO_H_
#define _TRACKINFO_H_

#include <glib-object.h>

#define BMP_TYPE_TRACKINFO		  (bmp_trackinfo_get_type ())
#define BMP_TRACKINFO(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_TRACKINFO, BmpTrackInfo))
#define BMP_TRACKINFO_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_TRACKINFO, BmpTrackInfoClass))
#define BMP_IS_TRACKINFO(obj)		  (GTK_CHECK_TYPE ((obj), BMP_TYPE_TRACKINFO))
#define BMP_IS_TRACKINFO_CLASS(klass)	  (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_TRACKINFO))
#define BMP_TRACKINFO_GET_CLASS(obj)	  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_TRACKINFO, BmpTrackInfoClass))

typedef struct _BmpTrackInfo BmpTrackInfo;
typedef struct _BmpTrackInfoClass BmpTrackInfoClass;
typedef struct _BmpTrackInfoPrivate BmpTrackInfoPrivate;

struct _BmpTrackInfo {
	GObject parent;

        BmpTrackInfoPrivate *private;

    	GtkWidget *window;
};

struct _BmpTrackInfoClass {
	GObjectClass parent;
};

GType 
bmp_trackinfo_get_type	(void);

BmpTrackInfo*
bmp_trackinfo_new	(void);
 
void 
bmp_trackinfo_show	(BmpTrackInfo *this, BmpFileItem *item);

void
bmp_trackinfo_clear	(BmpTrackInfo *this);
 
#endif
