/*  BMPx - The Dumb Music Player
 *  Copyright (C) 2005 BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * The BMPx project hereby grant permission for non-gpl compatible GStreamer
 * plugins to be used and distributed together with GStreamer and BMPx. This
 * permission are above and beyond the permissions granted by the GPL license
 * BMPx is covered by.
 */

#include <gtk/gtk.h>

#include "main.h"

#include "resource_manager.h"

#include "ui_main.h"
#include "ui_playlist.h"
#include "ui_dialog_preferences.h"
#include "ui_dialog_trackinfo.h"

static gboolean _keep_above = FALSE;
static gboolean _keep_above_save = FALSE;

void
wm_init ()
{
}

void
wm_set_keep_above (gboolean keep_above)
{
  BmpPreferences       *w_prefs;
  BmpTrackInfo	       *w_trackinfo;

  BmpWindowPlaylist    *w_pl;
  BmpWindowMain	       *w_main;

  GtkWindow	       *window;

  _keep_above = keep_above;

  w_main = RM_GET_ITEM ("windows", "window-main", NOLOCK); 
  g_assert (w_main);
  gtk_window_set_keep_above (GTK_WINDOW(w_main->window),
			     keep_above);

  w_pl = RM_GET_ITEM ("windows", "window-playlist", NOLOCK); 
  g_assert (w_pl);
  gtk_window_set_keep_above (GTK_WINDOW(w_pl->window),
			     keep_above);

  w_prefs = RM_GET_ITEM ("dialogs", "dialog-preferences", NOLOCK); 
  g_assert (w_prefs);
  gtk_window_set_keep_above (GTK_WINDOW(w_prefs->window),
			     keep_above);

  w_trackinfo = RM_GET_ITEM ("dialogs", "dialog-trackinfo", NOLOCK); 
  g_assert (w_trackinfo);
  gtk_window_set_keep_above (GTK_WINDOW(w_trackinfo->window),
			     keep_above);

  window = RM_GET_ITEM ("windows", "window-dialog-library", NOLOCK); 
  gtk_window_set_keep_above (window,
			     keep_above);

  window = RM_GET_ITEM ("windows", "window-dialog-streams", NOLOCK); 
  gtk_window_set_keep_above (window,
			     keep_above);
}

void
wm_reset_keep_above ()
{
  wm_set_keep_above (_keep_above);
}
 
void
wm_about_start (void)
{
  GtkWidget  *window;

  _keep_above_save = _keep_above;

  wm_set_keep_above (FALSE);

  window = RM_GET_ITEM ("windows", "window-dialog-about", NOLOCK); 
  gtk_window_set_keep_above (GTK_WINDOW(window),
			     TRUE);
}

void
wm_about_stop (void)
{
  GtkWidget  *window;

  wm_set_keep_above (_keep_above_save);

  window = RM_GET_ITEM ("windows", "window-dialog-about", NOLOCK); 
  gtk_window_set_keep_above (GTK_WINDOW(window),
			     FALSE);
}

